
%NOLIST
;============================================================================
;
; DPB.INC
; Disk Parameter Block definition.
; This file is part of the
;
; PseudoCD package (version 02)
; Copyright (C) 1997  C.Kulms
;
;   This is free software; you can redistribute it and/or modify it
;   under the terms of the GNU General Public License as published by
;   the Free Software Foundation; version 2 of the License.
;
;   This software is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.
;
;   You should have received a copy of the GNU General Public License
;   along with this software; if not, write to the Free Software
;   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;
;============================================================================*/
%LIST

STRUC sDPB					;Disk Parameter Block
dpbDrive	db ?			;DOS drive(r) number
dpbUnit		db ?			;sub-unit of disk's device-driver
dpbBPS		dw ?			;bytes per sector
dpbSPCmask	db ?			;sectors per cluster - 1
dpbSPCshift	db ?			;sectors per cluster as shift-value
dpbSecRsvd	dw ?			;number of reserved sectors
dpbNumFAT	db ?			;number of FATs
dpbNumRDE	dw ?			;number Root Directory Entries
dpbFirstSec	dw ?			;first sector of data-area
dpbMaxClu	dw ?			;number of clusters
dpbSPFAT	dw ?			;sectors per FAT
dpbRootSec	dw ?			;first sector of root-directory
dpbDrvOff	dw ?			;pointer to disk's device-driver's header
dpbDrvSeg	dw ?
dpbMedia	db ?			;disk's media-type
dpbAccessd	db ?
dpbNextDPB	dd ?			;pointer to next DPB
dpbNextFree	dw ?			;number of next free cluster (if <> 0FFFFh)
dpbFree		dw ?			;number of free clusters
ENDS sDPB

;end of file 'DPB.INC'

